(***************************************************************************************************************)
(******                       This is the FeynRules mod-file for the Unbroken Standard model              ******)
(******                                                                                                   ******)
(******     Authors: J. Santiago                                                                          ******)
(******                                                                                                   ******)
(****** Choose whether Feynman gauge is desired.                                                          ******)
(****** If set to False, unitary gauge is assumed.                                                          ****)
(****** Feynman gauge is especially useful for CalcHEP/CompHEP where the calculation is 10-100 times faster. ***)
(****** Feynman gauge is not supported in MadGraph and Sherpa.                                              ****)
(***************************************************************************************************************)

(* ************************** *)
(* *****  Information   ***** *)
(* ************************** *)
M$ModelName = "Dimension 6 SM Effective Lagrangian, 2 Fermions, 0 Scalars, 3 Derivative";

M$Information = {
  Authors      -> {"J. Santiago"}, 
  Version      -> "1.0",
  Date         -> "27. 04. 2016",
  Institutions -> {"CAFPE and Universidad de Granada"},
  Emails       -> {"jsantiago@ugr.es"}
};

FeynmanGauge = True;


(* ************************** *)
(* *****   Parameters   ***** *)
(* ************************** *)
M$Parameters = {

  (* External parameters *)

  (* Internal Parameters *)

  	 
  alphaR27 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR28 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR29 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR30 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR31 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR32 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR33 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR34 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR35 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR36 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR37 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR38 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR39 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR40 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR41 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaR42 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR43 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR44 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR45 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR46 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR47 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR48 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR49 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR50 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR51 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR52 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR53 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR54 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR55 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR56 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR57 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR58 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR59 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR60 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaR61 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]}
  },
  	 
  alphaE12 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE13 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE14 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE15 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE16 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE17 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE18 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE19 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE20 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE21 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE22 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE23 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE24 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE25 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE26 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE27 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE28 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE29 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE30 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  },
  	 
  alphaE31 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  }
  
};


(* ************************** *)
(* *****   Lagrangian   ***** *)
(* ************************** *)

(* Recall that Ta=sigma/2 *)
(* We have a change of notation wrt HEL *)
Wvec[mu_,nu_,ii_,jj_]:= Module[{aa},2 Ta[aa,ii,jj] FS[Wi,mu,nu,aa]];
Gvec[mu_,nu_,cc1_,cc2_]:= Module[{aa},2 T[aa,cc1,cc2] FS[G,mu,nu,aa]];
(* Define sigma[mu,nu]= I/2 [gamma(mu),gamma(nu)] *)
sigmamunu[mu_,nu_,sp_,sp2_]:=Module[{sp1},(I/2)*(Ga[mu,sp,sp1]*Ga[nu,sp1,sp2]-Ga[nu,sp,sp1]*Ga[mu,sp1,sp2])];

LF2S0D3 := Block[{lag,ff1,ff2,ii,mu,nu,mu1,nu1,rho,sp1,sp2,spi,jj,ii2,jj2,aa,cc,cc1,cc2,lagnoh},
      lag= ExpandIndices[
(*          alphaR28[ff1,ff2]*I*(LRbar[sp1,ff1].DC[DC[DC[LR[sp2,ff2],nu],nu],mu])*Ga[mu,sp1,sp2]
*)          alphaR28[ff1,ff2]*I*(LRbar[sp1,ff1].del[del[del[LR[sp2,ff2],nu],nu],mu]
                                 +I*g1*2*LRbar[sp1,ff1].del[LR[sp2,ff2],nu]*del[B[nu],mu]
                                 +I*g1*2*LRbar[sp1,ff1].del[del[LR[sp2,ff2],nu],mu]*B[nu]
                                 +I*g1*LRbar[sp1,ff1].LR[sp2,ff2]*del[del[B[nu],mu],nu]
                                 +I*g1*LRbar[sp1,ff1].del[LR[sp2,ff2],mu]*del[B[nu],nu]
                                 +I*g1*LRbar[sp1,ff1].del[del[LR[sp2,ff2],nu],nu]*B[mu]
                                 -g1^2*2*LRbar[sp1,ff1].LR[sp2,ff2]*B[nu]*del[B[nu],mu]
                                 -g1^2*LRbar[sp1,ff1].del[LR[sp2,ff2],mu]*B[nu]*B[nu]
                                 -g1^2*2*LRbar[sp1,ff1].del[LR[sp2,ff2],nu]*B[mu]*B[nu]
                                 -g1^2*LRbar[sp1,ff1].LR[sp2,ff2]*B[mu]*del[B[nu],nu]
                                 -I*g1^3*LRbar[sp1,ff1].LR[sp2,ff2]*B[nu]*B[nu]*B[mu]
                                 )*Ga[mu,sp1,sp2]
          ,FlavorExpand->SU2D];
	  lag
];


Ltot:= LF2S0D3;


