(***************************************************************************************************************)
(******                       This is the FeynRules mod-file for the Unbroken Standard model              ******)
(******                                                                                                   ******)
(******     Authors: J. Santiago                                                                          ******)
(******                                                                                                   ******)
(****** Choose whether Feynman gauge is desired.                                                          ******)
(****** If set to False, unitary gauge is assumed.                                                          ****)
(****** Feynman gauge is especially useful for CalcHEP/CompHEP where the calculation is 10-100 times faster. ***)
(****** Feynman gauge is not supported in MadGraph and Sherpa.                                              ****)
(***************************************************************************************************************)

(* ************************** *)
(* *****  Information   ***** *)
(* ************************** *)
M$ModelName = "Dimension 6 SM Effective Lagrangian, 2 Fermions, 0 Scalars, 3 Derivative";

M$Information = {
  Authors      -> {"J. Santiago"}, 
  Version      -> "1.0",
  Date         -> "27. 04. 2016",
  Institutions -> {"CAFPE and Universidad de Granada"},
  Emails       -> {"jsantiago@ugr.es"}
};

FeynmanGauge = True;


(* ************************** *)
(* *****   Parameters   ***** *)
(* ************************** *)
M$Parameters = {

  (* External parameters *)

  (* Internal Parameters *)

  	 
  alphaR28 == { 
    ParameterType    -> Internal,
    Indices          -> {Index[Generation],Index[Generation]},
    Hermitian        -> True
  }
  	 
  
};


(* ************************** *)
(* *****   Lagrangian   ***** *)
(* ************************** *)


Ltot := Block[{lag,ff1,ff2,ii,mu,nu,mu1,nu1,rho,sp1,sp2,spi,jj,ii2,jj2,aa,cc,cc1,cc2,lagnoh},
      lag= ExpandIndices[
          alphaR28[ff1,ff2]*I*(lRbar[sp1,ff1].DC[DC[DC[lR[sp2,ff2],nu],nu],mu])*Ga[mu,sp1,sp2]
          ,FlavorExpand->SU2D];
	  lag
];




