(* ************************** *)
(* *****  Information   ***** *)
(* ************************** *)
M$ModelName = "Scalar Singlet with zero hypercharge";

M$Information = {
  Authors      -> {"J. Santiago"}, 
  Version      -> "1.0",
  Date         -> "9. 11. 2016",
  Institutions -> {"CAFPE and Universidad de Granada"},
  Emails       -> {"jsantiago@ugr.es"}
};

FeynmanGauge = True;

(* ************************** *)
(* **** Particle classes **** *)
(* ************************** *)
M$ClassesDescription = {



  S[105] == {
    ClassName       -> Hs, 
    SelfConjugate   -> True,
    Mass            -> MHs,
    Width           -> 0
  }

};

(* ************************** *)
(* *****   Parameters   ***** *)
(* ************************** *)
M$Parameters = {

  (* External parameters *)

  (* Internal Parameters *)
  MHs == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  kaps == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  kaps3 == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  lams == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  lams4 == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  }

};


(* ************************** *)
(* *****   Lagrangian   ***** *)
(* ************************** *)

LNP := Block[{ii,mu},
    del[Hs,mu]*del[Hs,mu]/2-MHs^2*Hs^2/2
    -kaps*Hs*Phibar[ii]*Phi[ii]
    -kaps3*Hs^3
    -lams*Hs^2*Phibar[ii]*Phi[ii]
    -lams4*Hs^4
];

Ltot = LSM + LNP;



