(* ************************** *)
(* *****  Information   ***** *)
(* ************************** *)
M$ModelName = "Scalar Triplet with zero hypercharge";

M$Information = {
  Authors      -> {"J. Santiago"}, 
  Version      -> "1.0",
  Date         -> "15. 12. 2015",
  Institutions -> {"CAFPE and Universidad de Granada"},
  Emails       -> {"jsantiago@ugr.es"}
};

FeynmanGauge = True;

(* ************************** *)
(* **** Particle classes **** *)
(* ************************** *)
M$ClassesDescription = {



  S[105] == {
    ClassName       -> Tripi, 
    ClassMembers     -> {Trip1, Trip2, Trip3},
    Indices       -> {Index[SU2W]},
    FlavorIndex   -> SU2W,
    SelfConjugate   -> True,
    Mass            -> MHTrip,
    Width           -> 0
  }

};

(* ************************** *)
(* *****   Parameters   ***** *)
(* ************************** *)
M$Parameters = {

  (* External parameters *)

  (* Internal Parameters *)
  MHTrip == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  kapTrip == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  etaTrip == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  },

  lamTrip == { 
    ParameterType    -> Internal, 
    ComplexParameter  -> False
  }


};


(* ************************** *)
(* *****   Lagrangian   ***** *)
(* ************************** *)

LNP := Block[{a,ii,jj},
    DC[Tripi[a],mu]*DC[Tripi[a],mu]/2-MHTrip^2 Tripi[a]*Tripi[a]/2
    +kapTrip * Phibar[ii]*2*Ta[a,ii,jj]*Phi[jj]*Tripi[a]
    - etaTrip*Phibar[ii]*Phi[ii]*Tripi[a]*Tripi[a]
    - lamTrip*Tripi[a]*Tripi[a]*Tripi[b]*Tripi[b]/4
];

Ltot = LSM + LNP;




