(* ************************** *)
(* *****  Information   ***** *)
(* ************************** *)
M$ModelName = "VL_Quark_Doublet_Y_1_6";

M$Information = {
  Authors      -> {"J. Santiago"}, 
  Version      -> "1.0",
  Date         -> "23. 02. 2016",
  Institutions -> {"CAFPE and Universidad de Granada"},
  Emails       -> {"jsantiago@ugr.es"}
};

FeynmanGauge = True;

(* ************************** *)
(* **** Particle classes **** *)
(* ************************** *)
M$ClassesDescription = {

  F[105] == {
    ClassName        -> HT,
    Indices          -> {Index[Colour]},
    SelfConjugate    -> False,
    QuantumNumbers -> {Y -> 1/6},
    Mass             -> MHQ,
    Width            -> 0
  },

  F[106] == {
    ClassName        -> HB,
    Indices          -> {Index[Colour]},
    SelfConjugate    -> False,
    QuantumNumbers -> {Y -> 1/6},
    Mass             -> MHQ,
    Width            -> 0
  },

 F[107] == { 
    ClassName      -> HQ, 
    Unphysical     -> True, 
    Indices        -> {Index[SU2D], Index[Colour]},
    FlavorIndex    -> SU2D,
    SelfConjugate  -> False,
    QuantumNumbers -> {Y -> 1/6},
    Definitions    -> { 
      HQ[sp1_,1,cc_] :> HT[sp1,cc], 
      HQ[sp1_,2,cc_] :> HB[sp1,cc] }
  }



};

(* ************************** *)
(* *****   Parameters   ***** *)
(* ************************** *)
M$Parameters = {

  (* External parameters *)

  (* Internal Parameters *)
  lamprimeT == { 
    ParameterType     -> Internal, 
    Indices           -> {Index[Generation]},
    ComplexParameter  -> True
  },

  lamprimeB == { 
    ParameterType     -> Internal, 
    Indices           -> {Index[Generation]},
    ComplexParameter  -> True
  },

  MHQ == { 
    ParameterType     -> Internal, 
    ComplexParameter  -> False
  }

};


(* ************************** *)
(* *****   Lagrangian   ***** *)
(* ************************** *)


LHeavy := Block[{mu}, 
  I*(HQbar.Ga[mu].DC[HQ, mu])-MHQ*HQbar.HQ
];



LHeavylight := Block[{sp,ii,jj,cc,ff1,ff2,ff3,yuk},
 
  yuk = ExpandIndices[
   -lamprimeT[ff1] HQbar[sp, ii, cc].UR [sp, ff1, cc] Phibar[jj] Eps[ii, jj]
   -lamprimeB[ff1] HQbar[sp, ii, cc].DR [sp, ff1, cc] Phi[ii], FlavorExpand -> SU2D];
  yuk+HC[yuk]
 ];

LNP := LHeavy + LHeavylight;


Ltot = LSM + LNP;



