(* ************************** *)
(* *****  Information   ***** *)
(* ************************** *)
M$ModelName = "VL_Quark_Singlet_Y_2_3";

M$Information = {
  Authors      -> {"J. Santiago"}, 
  Version      -> "1.0",
  Date         -> "23. 02. 2016",
  Institutions -> {"CAFPE and Universidad de Granada"},
  Emails       -> {"jsantiago@ugr.es"}
};

FeynmanGauge = True;

(* ************************** *)
(* **** Particle classes **** *)
(* ************************** *)
M$ClassesDescription = {


  F[105] == {
    ClassName        -> HT,
    Indices          -> {Index[Colour]},
    SelfConjugate    -> False,
    QuantumNumbers -> {Y -> 2/3},
    Mass             -> MHT,
    Width            -> 0
  }

};

(* ************************** *)
(* *****   Parameters   ***** *)
(* ************************** *)
M$Parameters = {

  (* External parameters *)

  (* Internal Parameters *)
  lamprime == { 
    ParameterType     -> Internal, 
    Indices           -> {Index[Generation]},
    ComplexParameter  -> True
  },

  MHT == { 
    ParameterType     -> Internal, 
    ComplexParameter  -> False
  }

};


(* ************************** *)
(* *****   Lagrangian   ***** *)
(* ************************** *)


LHeavy := Block[{mu}, 
  I*(HTbar.Ga[mu].DC[HT, mu])-MHT*HTbar.HT
];



LHeavylight := Block[{sp,ii,jj,cc,ff1,ff2,ff3,yuk},
 
  yuk = ExpandIndices[
   -lamprime[ff1] QLbar[sp, ii, ff1, cc].HT [sp, cc] Phibar[jj] Eps[ii, jj], FlavorExpand -> SU2D];
  yuk+HC[yuk]
 ];

LNP := LHeavy + LHeavylight;

Ltot = LSM + LNP;


