(* ::Package:: *)

BeginPackage["FR2QGRAF`",{"FeynRules`"}]

FR2QGRAF::usage = "Create the necessary files to generate the QGRAF model"

Begin["`Private`"]

WriteSymbolsFunctions[params_]:=Module[{tiri,newsymbols,newfunctions,str},
tiri=Table[{params[[i,1]],Length[Indices/.params[[i,2]]],ComplexParameter/.params[[i,2]]},{i,Length[params]}];
newsymbols={};
newfunctions={};
Do[
If[tiri[[i,2]]==0,AppendTo[newsymbols,tiri[[i,1]]]; If[tiri[[i,3]],AppendTo[newsymbols,ToExpression[ToString[tiri[[i,1]]]<>"bar"]]],AppendTo[newfunctions,tiri[[i,1]]]; AppendTo[newfunctions,ToExpression[ToString[tiri[[i,1]]]<>"bar"]]];
,{i,Length[tiri]}];
str=OpenWrite["model_data/newsymbols",FormatType->OutputForm];
Do[Write[str,ToString[newsymbols[[ii]]]];
,{ii,Length[newsymbols]}];
Close[str];
str=OpenWrite["model_data/newfunctions",FormatType->OutputForm];
Do[Write[str,ToString[newfunctions[[ii]]]];
,{ii,Length[newfunctions]}];
Close[str];
];

WriteQGRAFModel[classes_,feynrules_]:=Block[{masslist,partsandmass,str,sta,ta,partis,tas,res,massless,massive,masslesslist,massivelist,masslist0,datamasslist},
masslist={};
partsandmass={};
Print["Let's write the Qgraf model"];
str=OpenWrite["model",FormatType->OutputForm];
Write[str,"* propagators"];
Write[str,""];
Do[
If[MemberQ[{F,U},classes[[i,1,0]]],sta="-",sta="+"];
ta=ClassName/.classes[[i,2]];
(*Print[ClassName/.classes[[i,2]]];
 Print[ClassName/.classes[[i,2]]];*)
If[!UnphysicalQ[ta],
partis=ClassMemberList[ta];
Do[
AppendTo[masslist,Mass/.classes[[i,2]]];
tas=ToString[partis[[j]]];
AppendTo[partsandmass,{tas,masslist[[-1]]}];
If[SelfConjugateQ[ta],
res="  ["<>tas<>", "<>tas<>", "<>sta<>"]",
res="  ["<>tas<>", "<>tas<>"bar, "<>sta<>"]";
];
(*Print[res];*)
Write[str,res];
,{j,Length[partis]}]
];
,{i,Length[classes]}];
Write[str,""];
Write[str,"* vertices"];
Do[
res=StringReplace[ToString[Transpose[feynrules[[i,1]]][[1]]],{"{"->"[","}"->"]"," "->""}];
(*Print[res];*)
Write[str,res];
,{i,Length[feynrules]}];
Close[str];
massless=Transpose[Select[partsandmass,ToString[#[[2]]]=="0"&]][[1]];
Off[Transpose::nmtx];
massive=Transpose[Select[partsandmass,ToString[#[[2]]]!="0"&]][[1]];
On[Transpose::nmtx];
If[Length[massless]>0,masslesslist=ToString[massless[[1]]];
Do[masslesslist=masslesslist<>", "<>ToString[massless[[i]]],{i,2,Length[massless]}],masslesslist<>""];
If[Length[massive]>0,massivelist=ToString[massive[[1]]];
Do[massivelist=massivelist<>", "<>ToString[massive[[i]]],{i,2,Length[massive]}],massivelist=""];
Export["model_data/listmassless",masslesslist,"Text"];
Export["model_data/listmassive",massivelist,"Text"];
masslist0=Union[masslist];
datamasslist="";
Do[datamasslist=datamasslist<>ToString[masslist0[[i]]]<>"  ",{i,Length[masslist0]}];
Print[datamasslist];
Export["model_data/listmass",datamasslist,"Text"];
];

WritePropagators[classes_]:=Module[{strprop,sta,ta,partis,colorfactor,den,num,tas,res},
strprop=OpenWrite["model_data/proplist",FormatType->OutputForm];
Do[
If[MemberQ[{F,U},classes[[i,1,0]]],sta="-",sta="+"];
ta=ClassName/.classes[[i,2]];
If[!UnphysicalQ[ta],
partis=ClassMemberList[ta];
colorfactor="";
If[Length[StringCases[ToString[Indices/.classes[[i,2]]],"Colour"]]>0,colorfactor="*deltaF(ii1,ii2)"];
If[Length[StringCases[ToString[Indices/.classes[[i,2]]],"Gluon"]]>0,colorfactor="*deltaF(aa1,aa2)"];
den="*prop(pp1,"<>ToString[Mass/.classes[[i,2]]]<>")";
num="";
If[MemberQ[{S},classes[[i,1,0]]],num="I"];
If[MemberQ[{U},classes[[i,1,0]]],num="I"];
If[MemberQ[{V},classes[[i,1,0]]],num="(-I)*deltaF(mumu1,mumu2)"];
If[MemberQ[{F},classes[[i,1,0]]],num="I*(gam(yy1,pp1,yy2)+"<>ToString[Mass/.classes[[i,2]]]<>"*gi(yy1,yy2))"];
Do[
tas=ToString[partis[[j]]];
If[SelfConjugateQ[ta],
res=tas<>" "<>tas,
res=tas<>" "<>tas<>"bar"];
Write[strprop,res<>" "<>num<>den<>colorfactor];
(*Print[res<>" "<>num<>den<>colorfactor];*)
,{j,Length[partis]}];
];
,{i,Length[classes]}];
Close[strprop];
];

WritePolarizations[classes_]:=Module[{strcpol,ta,partis,tas,res,strpol,chirality,chiralitybar},
(* cpol is for incoming momenta *)
strcpol=OpenWrite["model_data/cpollist",FormatType->OutputForm];
Do[
ta=ClassName/.classes[[i,2]];
If[!UnphysicalQ[ta],
partis=ClassMemberList[ta];
Do[
tas=ToString[partis[[j]]];
If[MemberQ[{S,U},classes[[i,1,0]]],
res={tas<>"  1"};
If[!SelfConjugateQ[ta],AppendTo[res,tas<>"bar 1"]]];
If[MemberQ[{V},classes[[i,1,0]]],
res={tas<>" Evect(pp1,mumu1)"};
If[!SelfConjugateQ[ta],AppendTo[res,tas<>"bar Evect(pp1,mumu1)"]]];
If[MemberQ[{F},classes[[i,1,0]]],
chirality="";
chiralitybar="";
If[ToString[Mass/.classes[[i,2]]]=="0",
If[StringTake[tas,-1]=="R",chirality="*gam(yy1,SIX,yy1)/2",chirality="*gam(yy1,SEVEN,yy1)/2"];
If[StringTake[tas,-1]=="R",chiralitybar="*gam(yy1,SEVEN,yy1)/2",chiralitybar="*gam(yy1,SIX,yy1)/2"];
];
res={tas<>" uspin(pp1,yy1)"<>chirality};
If[!SelfConjugateQ[ta],
AppendTo[res,tas<>"bar vbspin(pp1,yy1)"<>chiralitybar];]];
Do[
Write[strcpol,res[[jj]]];
,{jj,Length[res]}]
,{j,Length[partis]}]
];
,{i,Length[classes]}];
Close[strcpol];
(* pol is for outgoing momenta *)
strpol=OpenWrite["model_data/pollist",FormatType->OutputForm];
Do[
ta=ClassName/.classes[[i,2]];
If[!UnphysicalQ[ta],
partis=ClassMemberList[ta];
Do[
tas=ToString[partis[[j]]];
If[MemberQ[{S,U},classes[[i,1,0]]],
res={tas<>"  1"};
If[!SelfConjugateQ[ta],AppendTo[res,tas<>"bar 1"]]];
If[MemberQ[{V},classes[[i,1,0]]],
res={tas<>" Evectbar(pp1,mumu1)"};
If[!SelfConjugateQ[ta],AppendTo[res,tas<>"bar Evectbar(pp1,mumu1)"]]];
If[MemberQ[{F},classes[[i,1,0]]],
chirality="";
chiralitybar="";
If[StringTake[tas,-1]=="R",chirality="*gam(yy1,SIX,yy1)/2",chirality="*gam(yy1,SEVEN,yy1)/2"];
If[StringTake[tas,-1]=="R",chiralitybar="*gam(yy1,SEVEN,yy1)/2",chiralitybar="*gam(yy1,SIX,yy1)/2"];
res={tas<>" ubspin(pp1,yy1)"<>chiralitybar};
If[!SelfConjugateQ[ta],
AppendTo[res,tas<>"bar vspin(pp1,yy1)"<>chirality];]];
Do[
Write[strpol,res[[jj]]];
,{jj,Length[res]}];
,{j,Length[partis]}];
];
,{i,Length[classes]}];
Close[strpol];
];

WriteVertices[feynrules_]:=Module[{newreplrules00,newreplrules0,newreplrules0a,newreplrules1,newreplrules2,vertexnumber,str,parts,tala,re},
newreplrules00={Conjugate[a_[b___]]:>ToExpression[StringJoin[ToString[a],"bar"]][b],Conjugate[a_]:>ToExpression[StringJoin[ToString[a],"bar"]],TensDot[a1_,b___][Index[Spin,Ext[i_]],Index[Spin,Ext[j_]]]:>gam[Index[Spin,Ext[i]],a1,b,Index[Spin,Ext[j]]]};
newreplrules0={Index[Spin,Ext[i_]]:>ToExpression["yy"<>ToString[i]],Index[Colour,Ext[i_]]:>ToExpression["ii"<>ToString[i]],Index[Global`Generation,i_]:>i,Index[Gluon,Ext[i_]]:>ToExpression["aa"<>ToString[i]],Index[Lorentz,Ext[i_]]:>ToExpression["mumu"<>ToString[i]]};
newreplrules0a={Index[Lorentz,i_]:>i,Index[Gluon,i_]:>i,Index[Colour,i_]:>i};
newreplrules1={IndexDelta[a_,b_]:>deltaF[a,b],ProjM[a_,b_]:>gam[a,SEVEN,b]/2,ProjP[a_,b_]:>gam[a,SIX,b]/2,Ga[a_,b_,c_]:>gam[b,a,c],ME[Index[Lorentz,a_],Index[Lorentz,b_]]:>gi[a,b],FV[a_,b_]:>Mom[ToExpression["pp"<>ToString[a]],b],f[a_,b_,x_] f[c_,d_,x_]:>FF[a,b,c,d],SP[a_,b_]:>ToExpression["pp"<>ToString[a]].ToExpression["pp"<>ToString[b]],T[a_,i_,j_]:>Tc[i,a,j],f[a_,b_,c_]:>Fc[a,b,c]};
newreplrules1={IndexDelta[a_,b_]:>deltaF[a,b],ProjM[a_,b_]:>gam[a,SEVEN,b]/2,ProjP[a_,b_]:>gam[a,SIX,b]/2,Ga[a_,b_,c_]:>gam[b,a,c],ME[a_,b_]:>gi[a,b],FV[a_,b_]:>Mom[ToExpression["pp"<>ToString[a]],b],f[a_,b_,x_] f[c_,d_,x_]:>FF[a,b,c,d],SP[a_,b_]:>ToExpression["pp"<>ToString[a]].ToExpression["pp"<>ToString[b]],T[a_,i_,j_]:>Tc[i,a,j],f[a_,b_,c_]:>Fc[a,b,c]};
newreplrules2={Ga[x_]:>x,SlashedP[a_]:>ToExpression["pp"<>ToString[a]],gam[y1___,ProjM,y2___]:>gam[y1,SEVEN,y2]/2,gam[y1___,ProjP,y2___]:>gam[y1,SIX,y2]/2};
vertexnumber=Union[Table[Length[feynrules[[i,1]]],{i,Length[feynrules]}]];
str=Table[OpenWrite["model_data/v"<>ToString[vertexnumber[[i]]]<>"list",FormatType->OutputForm],{i,Length[vertexnumber]}];
Do[
parts=Transpose[feynrules[[i,1]]][[1]];
tala=InputForm[feynrules[[i,2]]];
(*Print[];
 Print[tala];*)
re=StringReplace[ToString[parts],{"{"->"","}"->"",","->" "}]<>"  "<>StringReplace[ToString[tala//.newreplrules00//.newreplrules0//.newreplrules0a//.newreplrules1//.newreplrules2],{Whitespace->"","mu$"->"mumudolar","Gluon$"->"aadolar","\[Alpha]"->"mumualpha","\[Beta]"->"mumubeta","\[Gamma]"->"mumugamma","\[Delta]"->"mumudelta","\[Epsilon]"->"mumuepsilon","\[CurlyEpsilon]"->"mumueps","Colour$"->"iidolar","FR2QGRAF`Private`"->""}];
											   (*Print[re];*)
WriteString[str[[Position[vertexnumber,Length[parts]][[1,1]]]],re<>"\n"];
,{i,Length[feynrules]}];
Do[Close[str[[i]]],{i,Length[str]}];
];

FR2QGRAF[feynrules_,classes_,params_]:=Block[{},
Print["Writing new symbols and functions"];
WriteSymbolsFunctions[params];
Print["done"];
Print["Writing QGRAF model"];
WriteQGRAFModel[classes,feynrules];
Print["done"];
Print["Writing propagators"];
WritePropagators[classes];
Print["done"];
Print["Writing Polarizations"];
WritePolarizations[classes];
Print["done"];
Print["Writing vertices"];
WriteVertices[feynrules];
Print["Model done"];
];

End[]

EndPackage[]


