#!/usr/bin/env python2
import file as jsf
import os
import subprocess
import sys
import glob

class DontDoIt(Exception): pass

def create_model(NPFRmodelname,modelname):
    modeldir="../models/"+modelname+'/'
    if os.path.isdir(modeldir):
        raise DontDoIt("Model directory "+modeldir+" already present")

    if not os.path.isfile(NPFRmodelname):
        raise DontDoIt("File "+NPFRmodelname+" is not present")

    myrepl= ('NewPhysicsModel','"'+NPFRmodelname+'"'),('TERE','TERE')
    jsf.dress_skeleton(myrepl,'FR2QGRAF.skeleton.m',"FR2QGRAF.script.m")
    if not os.path.isdir("model_data"):
        subprocess.call("mkdir model_data", shell=True)
    subprocess.call("math10 -script FR2QGRAF.script.m", shell=True)
    subprocess.call("rm -f FR2QGRAF.script.m", shell=True)

    with open("model_data/listmassive") as f:
        linesmassive = f.read().strip()
    with open("model_data/listmassless") as f:
        linesmassless = f.read().strip()
    os.makedirs(modeldir)
    os.makedirs(modeldir+"QGRAF")
    os.makedirs(modeldir+"QGRAF/proc_0loop")
    os.makedirs(modeldir+"FORM")
    os.makedirs(modeldir+"FORM/proc_0loop")
    subprocess.call("mv model* "+modeldir+"QGRAF/",shell=True)
    subprocess.call("cp limpia.sh "+modeldir+"FORM/proc_0loop/",shell=True)
    subprocess.call("cp colour.faux "+modeldir+"FORM/proc_0loop/",shell=True)
    myrepl= ('MASSLESSPARTICLES',linesmassless),('MASSIVEPARTICLES',linesmassive)
    jsf.dress_skeleton(myrepl,'qgraf.skeleton.0loop.dat',modeldir+"QGRAF/qgraf.skeleton.0loop.dat")
 

    if len(linesmassive)>0:        
        os.makedirs(modeldir+"QGRAF/proc_1loop")
        os.makedirs(modeldir+"FORM/proc_1loop")
        jsf.dress_skeleton(myrepl,'qgraf.skeleton.1loop.dat',modeldir+"QGRAF/qgraf.skeleton.1loop.dat")
        subprocess.call("cp limpia.sh "+modeldir+"FORM/proc_1loop/",shell=True)
        subprocess.call("cp colour.faux "+modeldir+"FORM/proc_1loop/",shell=True)

if __name__=='__main__':
    try:
        create_model(sys.argv[1],sys.argv[2])
    except DontDoIt as e:
        print(e.args[0])
